"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const EboxEvent_1 = require("../EboxEvent");
const constants_1 = require("../constants");
describe("Event System", () => {
    let instance;
    it("connection", (done) => {
        instance = new EboxEvent_1.EboxEvent('http://localhost');
        if (instance.connected) {
            done();
        }
        else {
            instance.on('connect', () => {
                done();
            });
            instance.on('connect_error', (err) => {
                //assert.equal(err, null || undefined, err.description.message)
                done(err.description.message);
            });
        }
    });
    it("broadcasting", (done) => {
        if (instance.connected) {
            instance.subscribe("app.testing");
            instance.onAction("testaction", (_arg) => {
                done();
            });
            const data = {
                id: "testaction",
                packageId: "app.testing",
                data: "this is it!"
            };
            instance.broadcast(data, (response) => console.log("Broadcast response " + response));
        }
        else {
            done("Not connected to broadcast action.");
        }
    });
    it("RPC", (done) => __awaiter(void 0, void 0, void 0, function* () {
        const response = yield instance.sendRPC(constants_1.SYSTEM_PACKAGE, "testrpc", "hello");
        console.log("Recieved " + response);
        done();
    }));
});
